/*  Project RBL
	 R.B. Logiciel
	 Copyright  1994..1995 All Rights Reserved.
	 SUBSYSTEM:    pmdi.exe Application
	 FILE:         datedlg.cpp
	 AUTHOR:       R. BERTHOU


	 OVERVIEW
	 ========
	 Source file for implementation of DateDlg (TDialog).
*/
#define RBL_US_    	//For US Format

#include "datedlg.h"

DEFINE_RESPONSE_TABLE1(DateDlg, TDialog)
	EV_WM_ACTIVATE,
	EV_BN_CLICKED(IDC_PREV_M, CmPrevMois),
	EV_BN_CLICKED(IDC_NEXT_M, CmNextMois),
	EV_LBN_SELCHANGE(IDC_LDATE,CmChoix),
END_RESPONSE_TABLE;



DateDlg::DateDlg (	TEditDate* parent,
							TResId 	resId,
							TModule* module)
	: TDialog(parent, resId, module)
{
	 lListe = new TListBox(this, IDC_LDATE);
	 EDt = parent ;
}


DateDlg::~DateDlg ()
{
	 delete lListe ;
	 Destroy();
}

void
DateDlg::CmPrevMois ()
{
	iMois-- ;
	if (iMois < 1) {
		iMois = 12;
		iAnnee--;
	}
	AfficheMois() ;
}

void
DateDlg::CmNextMois ()
{
	iMois++ ;
	if (iMois > 12) {
		iMois = 1;
		iAnnee++;
	}
	AfficheMois() ;

}

void
DateDlg::SetupWindow ()
{
	TDate dt ;
	TPoint point ;
	TDialog::SetupWindow();
	lListe->SetColumnWidth(((lListe->Attr.W-1)/ 7)) ;

#if defined RBL_US_
	SetDlgItemText(IDC_SEM,"Mo Tu. We Th.  Fri. Sa. Su.") ;
#endif

	//Rcupration de la date
	dt = 	EDt->GetText() ;

	// Affectation des coordonnes du point d'affichage
	point.x = EDt->Attr.X ;
	point.y = EDt->Attr.Y + EDt->Attr.H ;
	::ClientToScreen(EDt->GetParent(), &point) ;
	if (point.x > (GetSystemMetrics(SM_CXSCREEN) - TWindow::Attr.W ))
			point.x -= (-EDt->Attr.W + TWindow::Attr.W) ;
	if (point.y > (GetSystemMetrics(SM_CYSCREEN) - TWindow::Attr.H ))
			point.y -= (EDt->Attr.H + TWindow::Attr.H ) ;

	MoveWindow(point.x, point.y, TWindow::Attr.W, TWindow::Attr.H, TRUE);
	//

	iAnnee   = dt.Year() ;
	iMois    = dt.Month() ;
	iJour    = dt.DayOfMonth() ;

	AfficheMois() ;
}

void
DateDlg::AfficheMois()
{
#if !defined RBL_US_
	static const char *sMois[12] =
	{"Janvier",	"Fvrier",	"Mars",
	 "Avril",	"Mai",		"Juin",
	 "Juillet",	"Aot",		"Septembre",
	 "Octobre",	"Novembre",	"Dcembre"	}   ;
#endif

	int iPos = -1 ;
	int j = 0 ;
	int i = 1;
	char *buff ;
	buff = new char[25] ;

#if !defined RBL_US_
	wsprintf(buff,"%s %d",sMois[iMois-1], iAnnee);
#else
	wsprintf(buff,"%s %d",TDate(1,iMois, iAnnee).NameOfMonth(), iAnnee) ;
#endif

	lListe->ClearList() ;
	SetDlgItemText(IDC_MOIS,buff) ;

	iSemaine = TDate(1,iMois, iAnnee).WeekDay() ;
	if (iMois == 12)
		 iLast = 31 ;
	else
		iLast		= (TDate(1,iMois+1, iAnnee)-1).DayOfMonth() ;

	int iCol, iLigne ;
	iCol = 0 ;
	while (iCol < 7) {
		iLigne = 0;
		iCol++;
		while (iLigne < 6) {
			i = iCol + (iLigne * 7) ;
			if ( (i < iSemaine) ||
				  (i >= iLast + iSemaine) ) {
				lListe->AddString("") ;
			}
			else {
				wsprintf(buff,"%2.2d",i-iSemaine+1) ;
				j = lListe->AddString(buff) ;
				if (iJour == (i-iSemaine+1)) {
					iPos = j ;
				}
			}
			iLigne++;
		}
	}
	delete buff ;
	if (iPos > -1) {
		lListe->SetSelIndex(iPos) ;
	}

}

void
DateDlg::CmChoix()
{
	char *buff ;
	buff = new char[5] ;
	if (lListe->GetString(buff,lListe->GetSelIndex()) > 1) {
		iJour = atoi(buff) ;
		EDt->SetText(iJour,iMois,iAnnee) ;
		iLast = -2 ;
		TDialog::CmOk() ;
		EDt->SetFocus() ;
	}
	delete buff ;
}


void
DateDlg::EvActivate(UINT active, bool min, HWND hWnd)
{
	if (active)
		TDialog::EvActivate(active, min, hWnd);
	else
		if (iLast > -2) {
			iLast = -2 ;
			TDialog::CmCancel() ;
		}
}
