#if !defined(_EDITDATE_H)
#define _EDITDATE_H

#include <owl\edit.h>
#include <owl\validate.h>
#include <classlib\date.h>
#include <owl\button.h>

class DateDlg ;
class RButton ;

class TEditDate : public TEdit
{
  void EvChar(UINT key, UINT repeatCount, UINT flags) ;

  TDate	dt, dtDeb ;
  RButton	*bCal ;
  DateDlg	*dtDlg ;
  void EvSetFocus(HWND hWndLostFocus);
  void EvKillFocus(HWND hWndGetFocus);
  void GetDate(int iType = 0) ;
  void SetupWindow() ;

 public :
	TEditDate(TWindow* parent, int resourceID, TDate dt = TDate()-1,
				 UINT textLen = 11, TModule* module = 0);
	TEditDate(TWindow* parent,	int id,
				 int x, int y, int w, int h,
				 TDate dt = TDate()-1,
				 uint            textLen = 11,
				 bool            multiline = false,
				 TModule*        module = 0);


	~TEditDate() ;

   void 		CmCal() ;
	void 		SetText(const char far* str);
	void 		SetText(int iJour, int iMois, int iAnnee) ;
	void 		SetText(TDate dtTemp) ;
	void 		SetModify() {HandleMessage(EM_SETMODIFY, TRUE);}

	void GetText(char far* str, int maxChar = 11) { TEdit::GetText(str,maxChar); }
	void GetText(int &iJour, int &iMois, int &iAnnee) ;
	TDate GetText() {return dt; }

  DECLARE_RESPONSE_TABLE(TEditDate);
};

//
// class TDateValidator
// ----- ----------------
//
class TDateValidator : public TValidator {
  public:
	 TDateValidator(const int iFormat = 0);
	 //
	 // override TValidator's virtuals
	 //
	 void         Error();
	 BOOL         IsValid(const char far* str);

  protected:
	 TDate     	  Dt;

//  DECLARE_STREAMABLE(TDateValidator, 1);
};

class RButton : public TButton
{
	public:
	 RButton(TWindow*        parent,
				int             id = 0,
				const char far* text = "",
				TEditDate*		 = 0,
				int X = 0, int Y = 0, int W = 5, int H = 5,
				bool            isDefault = false,
				TModule*        module = 0);

  protected:
	 char far* GetClassName() { return "BUTTON"; }
	 void EvClicked();
	 TEditDate* EDt ;

	DECLARE_RESPONSE_TABLE(RButton);

};

extern void ConvDate(char * strDate,	// format JJ/MM/AA
							int&  iJour,
							int&  iMois,
							int&  iAnnee ) ;

#endif
